//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         dialogcustomizer.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for DialogCustomizer (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(dialogcustomizer_h)              // Sentry, use file only if it's not already included.
#define dialogcustomizer_h

#include <owl/dialog.h>


#include <owl/commctrl.h>
#include "weinadminapp.rh"            // Definition of all resources.
#include <owl/edit.h>
#include <owl/combobox.h>
#include <owl/checkbox.h>
#include <owl/button.h>

#include <pbk/modulebroker/modulebroker.h>


//{{TDialog = DialogCustomizer}}
struct DialogCustomizerXfer {
//{{DialogCustomizerXFER_DATA}}
    uint    pEuroPreise;
    TComboBoxData  pGeogruppe;
    TComboBoxData  pPreisliste;
    char    pWaehrung[ 255 ];
    uint    pMWSEnthalten;
    char    pMWS[ 255 ];
    char    pVordatierung[ 255 ];
    char    pBemerkung[ 255 ];
//{{DialogCustomizerXFER_DATA_END}}
};

class DialogCustomizer : public TDialog {
  protected:
    ModuleBroker* _p_module_broker;

  public:
    DialogCustomizer(TWindow* parent, ModuleBroker* pModuleBroker, TResId resId = IDD_CUSTOMIZER, TModule* module = 0);
    virtual ~DialogCustomizer();

//{{DialogCustomizerVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{DialogCustomizerVIRTUAL_END}}

//{{DialogCustomizerXFER_DEF}}
  protected:
    TCheckBox* pEuroPreise;
    TComboBox* pGeogruppe;
    TComboBox* pPreisliste;
    TEdit* pWaehrung;
    TCheckBox* pMWSEnthalten;
    TEdit* pMWS;
    TEdit* pVordatierung;
    TEdit* pBemerkung;

//{{DialogCustomizerXFER_DEF_END}}

//{{DialogCustomizerRSP_TBL_BEGIN}}
  protected:
    void CmAddGeogruppe();
    void CmAddPreisliste();
    void CmOk();
//{{DialogCustomizerRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(DialogCustomizer);
};    //{{DialogCustomizer}}


#endif  // dialogcustomizer_h sentry.

