//----------------------------------------------------------------------------
//  Project weinadmin
//
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         druckdialog.cpp
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of DruckDialog (TDialog).
//
//----------------------------------------------------------------------------
#include <owl/pch.h>

#include "druckdialog.h"
#include "weinadminapp.rh"

//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(DruckDialog, TDialog)
//{{DruckDialogRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDC_DD_BILDSCHIRM, CmBildschirm),
  EV_BN_CLICKED(IDC_DD_DRUCKER, CmDrucker),
  EV_BN_CLICKED(IDC_DD_PACKLISTE, CmPackListe),
  EV_BN_CLICKED(IDC_DD_RECHNUNG, CmRechnungen),
  EV_BN_CLICKED(IDC_DD_RECH_INT, CmRechnungIntern),
//{{DruckDialogRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{DruckDialog Implementation}}


DruckDialog::DruckDialog(TWindow* parent, bool& PrintPackliste, bool& PrintRechnung, bool& PrintRechnungIntern, bool& PreView, TResId resId, TModule* module)
:
    TDialog(parent, resId, module), _print_rechnung(PrintRechnung), _print_rechnung_intern(PrintRechnungIntern), _print_packliste(PrintPackliste), _pre_view(PreView)
{
  // INSERT>> Your constructor code here.

  _print_rechnung = _print_packliste = _print_rechnung_intern = true;
  PreView = false;

  pRechnung = new TCheckBox(this, IDC_DD_RECHNUNG);
  pRechnungIntern = new TCheckBox(this, IDC_DD_RECH_INT);
  pPackliste = new TCheckBox(this, IDC_DD_PACKLISTE);
  pBildschirm = new TRadioButton(this, IDC_DD_BILDSCHIRM);
  pDrucker = new TRadioButton(this, IDC_DD_DRUCKER);
}


DruckDialog::~DruckDialog()
{
  Destroy(IDCANCEL);

  // INSERT>> Your destructor code here.

}


void DruckDialog::CmBildschirm()
{
  // INSERT>> Your code here.

  _pre_view = true;
}


void DruckDialog::CmDrucker()
{
  // INSERT>> Your code here.

  _pre_view = false;
}


void DruckDialog::CmPackListe()
{
  // INSERT>> Your code here.

  _print_packliste = !_print_packliste;
}


void DruckDialog::CmRechnungen()
{
  // INSERT>> Your code here.

  _print_rechnung = !_print_rechnung;
}


void DruckDialog::CmRechnungIntern()
{
  // INSERT>> Your code here.

  _print_rechnung_intern = !_print_rechnung_intern;
}


void DruckDialog::SetupWindow()
{
	TDialog::SetupWindow();

	// INSERT>> Your code here.

  _print_rechnung = _print_packliste = _print_rechnung_intern = true;

  pRechnung->SetCheck(BF_CHECKED);
  pRechnungIntern->SetCheck(BF_CHECKED);
  pPackliste->SetCheck(BF_CHECKED);
  pDrucker->SetCheck(BF_CHECKED);
}
