//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         druckdialog.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for DruckDialog (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(druckdialog_h)              // Sentry, use file only if it's not already included.
#define druckdialog_h

#include <owl/dialog.h>
#include <owl/checkbox.h>
#include <owl/radiobut.h>

#include <owl/commctrl.h>
#include "mck/rechnung/MCKrechnung.h"
#include "weinadminapp.rh"            // Definition of all resources.


//{{TDialog = DruckDialog}}
class DruckDialog : public TDialog {
  protected:
    bool& _pre_view, &_print_rechnung, &_print_rechnung_intern, &_print_packliste;

	 TCheckBox *pRechnung;
	 TCheckBox *pRechnungIntern;
    TCheckBox *pPackliste;
    TRadioButton *pBildschirm;
    TRadioButton* pDrucker;


  public:
    DruckDialog(TWindow* parent, bool&, bool&, bool&, bool&, TResId resId = IDD_DRUCKDIALOG, TModule* module = 0);
    virtual ~DruckDialog();

//{{DruckDialogVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{DruckDialogVIRTUAL_END}}

//{{DruckDialogRSP_TBL_BEGIN}}
  protected:
    void CmBildschirm();
    void CmDrucker();
    void CmPackListe();
    void CmRechnungen();
    void CmRechnungIntern();
//{{DruckDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(DruckDialog);
};    //{{DruckDialog}}


#endif  // druckdialog_h sentry.

