//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         geofilterdlg.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for GeoFilterDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(geofilterdlg_h)              // Sentry, use file only if it's not already included.
#define geofilterdlg_h

#include <owl/dialog.h>


#include <owl/button.h>
#include <owl/checkbox.h>
#include <owl/edit.h>
#include <owl/commctrl.h>
#include "weinadminapp.rh"            // Definition of all resources.
#include <owl/listbox.h>

#include <pbk/modulebroker/modulebroker.h>


//{{TDialog = GeoFilterDlg}}
struct GeoFilterDlgXfer {
//{{GeoFilterDlgXFER_DATA}}
    TListBoxData  pGeoGruppe;
    char    pPLZBis[ 255 ];
    char    pPLZVon[ 255 ];
    uint    pUsePLZ;
    uint    pUseGeo;
//{{GeoFilterDlgXFER_DATA_END}}
};

class GeoFilterDlg : public TDialog {
  protected:
	ModuleBroker* _p_module_broker;
   
  public:
    GeoFilterDlg(TWindow* parent, ModuleBroker*, TResId resId = IDD_GEOFILTERDLG, TModule* module = 0);
    virtual ~GeoFilterDlg();

//{{GeoFilterDlgVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{GeoFilterDlgVIRTUAL_END}}

//{{GeoFilterDlgXFER_DEF}}
  protected:
    TListBox* pGeoGruppe;
    TEdit* pPLZBis;
    TEdit* pPLZVon;
    TCheckBox* pUsePLZ;
    TCheckBox* pUseGeo;
    TButton* pGeoDatei;

//{{GeoFilterDlgXFER_DEF_END}}

//{{GeoFilterDlgRSP_TBL_BEGIN}}
  protected:
    void CmAdressDatei();
    void CmUseGeo();
    void CmUsePLZ();
//{{GeoFilterDlgRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(GeoFilterDlg);
};    //{{GeoFilterDlg}}


#endif  // geofilterdlg_h sentry.

