//----------------------------------------------------------------------------
//  Project weinadmin
//
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         kundendialog.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for KundenDialog (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(kundendialog_h)              // Sentry, use file only if it's not already included.
#define kundendialog_h

#include <owl/dialog.h>
#include <owl/button.h>
#include <owl/edit.h>
#include <owl/static.h>
#include <owl/combobox.h>
#include <owl/commctrl.h>

#include "pbk/kunde/kunde.h"
#include <pbk/modulebroker/modulebroker.h>
#include "weinadminapp.rh"            // Definition of all resources.
#include "weinadminapp.h"

//{{TDialog = KundenDialog}}
struct KundenDialogXfer {
//{{KundenDialogXFER_DATA}}
    TComboBoxData  pAnrede;
    char    pBemerkung[ 255 ];
    char    pEMail[ 255 ];
    char    pFax[ 255 ];
    char    pNachname[ 255 ];
    char    pOrt[ 255 ];
    char    pPLZ[ 255 ];
    char    pStrasse[ 255 ];
    char    pTelefon[ 255 ];
    char    pTreffer[ 255 ];
    char    pVorname[ 255 ];
    char    pBmpEditieren[ 255 ];
    char    pBmpErfassen[ 255 ];
    char    pBmpRechnung[ 255 ];
    char    pBmpSuchen[ 255 ];
//{{KundenDialogXFER_DATA_END}}
};

class KundenDialog : public TDialog, KundenServer, RechnungsServer {
  public:
    enum Mode {ADD, SEARCH, EDIT, RECHNUNG};

  protected:
    Mode    			 	  _mode;
    Kunde   			 	  _current_kunde, *_p_kunde;
    bool				    	  _set_data_mode;
    bool						  _dirty; 						  // Daten verndert?

	 ModuleBroker* 		  _p_module_broker;
	 TSDIDecFrame* 		  _p_parent_window;
    TComboBox*            pGeoGruppe, *pPreisListe;
    long					     _internal_search_delay;

  public:
    KundenDialog(TWindow* parent, Mode, TSDIDecFrame*, ModuleBroker*, Kunde* = NULL, TResId resId = IDD_KUNDENDIALOG, TModule* module = 0);
    virtual ~KundenDialog();

    void FillKundenListe(GenericList<Kunde>&);
	 void FillRechnungsListe(GenericList<Rechnung>&, bool);

//{{KundenDialogVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
            void SetKunde(const Kunde&);
    virtual bool CanClose();
//{{KundenDialogVIRTUAL_END}}

//{{KundenDialogRSP_TBL_BEGIN}}
  protected:
    void ENChange();
	 void CmStore();
	 void CmClear();
    void CBNEditchange();
    void CBNSelchange();
    void CBNSelendok();
    void CmAddRechnung();
    void EvTimer(uint timerId);
    void CmOk();
    void CmPressReturn();
//{{KundenDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(KundenDialog);

//{{KundenDialogXFER_DEF}}
  protected:
    TComboBox* pAnrede;
    TEdit* pBemerkung;
    TButton* pClear;
    TEdit* pEMail;
    TEdit* pFax;
    TEdit* pNachname;
    TEdit* pOrt;
    TEdit* pPLZ;
    TButton* pStore;
    TEdit* pStrasse;
    TEdit* pTelefon;
    TEdit* pTreffer;
    TEdit* pVorname;
    TListBox* pTrefferListe;
    TStatic* pBmpEditieren;
    TStatic* pBmpErfassen;
    TStatic* pBmpRechnung;
    TStatic* pBmpSuchen;

//{{KundenDialogXFER_DEF_END}}
};    //{{KundenDialog}}


#endif  // kundendialog_h sentry.

