//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         kundenliste.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for KundenListe (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(kundenliste_h)              // Sentry, use file only if it's not already included.
#define kundenliste_h

#include <owl/dialog.h>


#include <owl/button.h>
#include <owl/edit.h>
#include <owl/combobox.h>
#include <owl/commctrl.h>
#include <owl/listwind.h>
#include "weinadminapp.rh"            // Definition of all resources.
#include "weinadminapp.h"

#include <list/list.h>
#include "pbk/kunde/kunde.h"
#include <pbk/modulebroker/modulebroker.h>

//{{TDialog = KundenListe}}
struct KundenListeXfer {
//{{KundenListeXFER_DATA}}
    char    pAdresse[ 255 ];
    char    pBemerkung[ 255 ];
    char    pEMail[ 255 ];
    char    pName[ 255 ];
    char    pOrt[ 255 ];
    char    pListen[ 255 ];
    char    pTel[ 255 ];
//{{KundenListeXFER_DATA_END}}
};

class KundenListe : public TDialog {
  protected:
    Kunde 					_current_kunde;
    GenericList<Kunde>* _p_kunden_liste;
	 TSDIDecFrame*       _p_parent_window;
    KundenServer*			_p_kunden_server;
    ModuleBroker*		   _p_module_broker;
    bool						_fuer_rechnung;

  public:
    KundenListe(TWindow* parent, TSDIDecFrame*, KundenServer*, ModuleBroker*, bool = false, TResId resId = IDD_KUNDENLISTE, TModule* module = 0);
    virtual ~KundenListe();

  protected:
    void FillList();
	 void ClearDisplay();

//{{KundenListeXFER_DEF}}
  protected:
    TListWindow* pKundenTabelle;
    TEdit* pAdresse;
    TEdit* pBemerkung;
    TButton* pDelete;
    TButton* pEdit;
    TEdit* pEMail;
    TEdit* pName;
    TEdit* pOrt;
    TEdit* pListen;
    TEdit* pTel;
    TButton* pRechnung;

//{{KundenListeXFER_DEF_END}}

//{{KundenListeVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{KundenListeVIRTUAL_END}}

//{{KundenListeRSP_TBL_BEGIN}}
  protected:
    void EvLButtonDblClk(uint modKeys, TPoint& point);
    void LVNGetdispinfo(TLwDispInfoNotify& lwdin);
    bool CmClickTabelle(TLwNotify& lwn);
    void CmEditKunde();
    void CmDeleteKunde();
    void CmNewRechnung();
//{{KundenListeRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(KundenListe);
};    //{{KundenListe}}


#endif  // kundenliste_h sentry.

