//----------------------------------------------------------------------------
//  Project weinadmin
//
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         merkzetteldlg.cpp
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of MerkzettelDlg (TDialog).
//
//----------------------------------------------------------------------------
#include <owl/pch.h>

#include "merkzetteldlg.h"


//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(MerkzettelDlg, TDialog)
//{{MerkzettelDlgRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDCANCEL, CmCancel),
  EV_EN_CHANGE(IDC_EDIT7, CmChange),
  EV_WM_MOVE,
//{{MerkzettelDlgRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{MerkzettelDlg Implementation}}


static MerkzettelDlgXfer MerkzettelDlgData;

MerkzettelDlg::MerkzettelDlg(TWindow* parent, MerkzettelVerwaltung::MerkzettelIntern& Merkzettel, TResId resId, TModule* module)
:
    TDialog(parent, resId, module), _merkzettel(Merkzettel)
{
//{{MerkzettelDlgXFER_USE}}
  pTextfeld = new TEdit(this, IDC_EDIT7, 255);

  SetTransferBuffer(&MerkzettelDlgData);
//{{MerkzettelDlgXFER_USE_END}}

  // INSERT>> Your constructor code here.
}


MerkzettelDlg::~MerkzettelDlg()
{
  Destroy(IDCANCEL);

  // INSERT>> Your destructor code here.
}


void MerkzettelDlg::SetupWindow()
{
  TDialog::SetupWindow();

  // INSERT>> Your code here.

  TRect rect;

  SetCaption("Merkzettel");
  GetWindowRect(rect);
  pTextfeld->SetText(_merkzettel._text);
  MoveWindow(_merkzettel._x, _merkzettel._y, rect.right - rect.left, rect.bottom - rect.top);
}

void MerkzettelDlg::Destroy(int retVal)
{
  TDialog::Destroy(retVal);

  // INSERT>> Your code here.
}


void MerkzettelDlg::CmCancel()
{
  // INSERT>> Your code here.

  pTextfeld->Clear();
  Destroy();
}


void MerkzettelDlg::CmChange()
{
  // INSERT>> Your code here.

  pTextfeld->GetText(_merkzettel._text, 350);
}


void MerkzettelDlg::EvMove(TPoint& clientOrigin)
{
    TDialog::EvMove(clientOrigin);

  // INSERT>> Your code here.

  _merkzettel._x = clientOrigin.x;
  _merkzettel._y = clientOrigin.y;
}

