//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         merkzetteldlg.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for MerkzettelDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(merkzetteldlg_h)              // Sentry, use file only if it's not already included.
#define merkzetteldlg_h

#include <owl/dialog.h>


#include <owl/commctrl.h>
#include "weinadminapp.rh"            // Definition of all resources.
#include <owl/edit.h>

#include <pbk/merkzettelverwaltung/merkzettelverwaltung.h>

//{{TDialog = MerkzettelDlg}}
struct MerkzettelDlgXfer {
//{{MerkzettelDlgXFER_DATA}}
    char    pTextfeld[ 255 ];
//{{MerkzettelDlgXFER_DATA_END}}
};

class MerkzettelDlg : public TDialog {
  protected:
    MerkzettelVerwaltung::MerkzettelIntern& _merkzettel;

  public:
    MerkzettelDlg(TWindow* parent, MerkzettelVerwaltung::MerkzettelIntern&, TResId resId = IDD_MERKZETTEL, TModule* module = 0);
    virtual ~MerkzettelDlg();

//{{MerkzettelDlgXFER_DEF}}
  protected:
    TEdit* pTextfeld;

//{{MerkzettelDlgXFER_DEF_END}}

//{{MerkzettelDlgVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
    virtual void Destroy(int retVal = 0);
//{{MerkzettelDlgVIRTUAL_END}}

//{{MerkzettelDlgRSP_TBL_BEGIN}}
  protected:
    void CmCancel();
    void CmChange();
    void EvMove(TPoint& clientOrigin);
//{{MerkzettelDlgRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(MerkzettelDlg);
};    //{{MerkzettelDlg}}


#endif  // merkzetteldlg_h sentry.

