//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         rechnungsfiler.cpp
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of RechnungsFiler (TDialog).
//
//----------------------------------------------------------------------------
#include <owl/pch.h>
#include <stdio.h>

#include "rechnungsfiler.h"


//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(RechnungsFiler, TDialog)
//{{RechnungsFilerRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDC_RF_ERFASSUNG, CmErfassung),
  EV_BN_CLICKED(IDC_RF_DATIERUNG, CmDatierung),
  EV_BN_CLICKED(IDC_RF_E_UEBERNEHMEN, CmUebernehmen),
  EV_BN_CLICKED(IDC_RF_E_HEUTE, CmErfassungHeute),
  EV_BN_CLICKED(IDC_RF_D_HEUTE, CmDatierungHeute),
  EV_BN_CLICKED(IDOK, Cm_Ok),
  EV_EN_CHANGE(IDC_RF_D_FIRST_DAY, ENChange),
  EV_EN_CHANGE(IDC_RF_D_FIRST_MONTH, ENChange),
  EV_EN_CHANGE(IDC_RF_D_FIRST_YEAR, ENChange),
  EV_EN_CHANGE(IDC_RF_D_LAST_DAY, ENChange),
  EV_EN_CHANGE(IDC_RF_D_LAST_MONTH, ENChange),
  EV_EN_CHANGE(IDC_RF_D_LAST_YEAR, ENChange),
  EV_EN_CHANGE(IDC_RF_E_FIRST_DAY, ENChange),
  EV_EN_CHANGE(IDC_RF_E_FIRST_MONTH, ENChange),
  EV_EN_CHANGE(IDC_RF_E_FIRST_YEAR, ENChange),
  EV_EN_CHANGE(IDC_RF_E_LAST_DAY, ENChange),
  EV_EN_CHANGE(IDC_RF_E_LAST_MONTH, ENChange),
  EV_EN_CHANGE(IDC_RF_E_LAST_YEAR, ENChange),
//{{RechnungsFilerRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{RechnungsFiler Implementation}}


static RechnungsFilerXfer RechnungsFilerData;

RechnungsFiler::RechnungsFiler(TWindow* parent, TDate& Erfassung_first, TDate& Erfassung_last,
										 TDate& Datierung_first, TDate& Datierung_last, bool& use_erfassung,
                               bool& use_datierung, ModuleBroker* pModuleBroker, TResId resId, TModule* module)
:
    TDialog(parent, resId, module), _erfassung_first(Erfassung_first), _erfassung_last(Erfassung_last),
    _datierung_first(Datierung_first), _datierung_last(Datierung_last), _use_erfassung(use_erfassung),
    _use_datierung(use_datierung), _p_module_broker(pModuleBroker)
{
//{{RechnungsFilerXFER_USE}}
  pDatierung = new TCheckBox(this, IDC_RF_DATIERUNG, 0);
  pDatierungFirstDay = new TEdit(this, IDC_RF_D_FIRST_DAY, 255);
  pDatierungFirstMonth = new TEdit(this, IDC_RF_D_FIRST_MONTH, 255);
  pDatierungFirstYear = new TEdit(this, IDC_RF_D_FIRST_YEAR, 255);
  pDatierungHeute = new TButton(this, IDC_RF_D_HEUTE);
  pDatierungLastDay = new TEdit(this, IDC_RF_D_LAST_DAY, 255);
  pDatierungLastMonth = new TEdit(this, IDC_RF_D_LAST_MONTH, 255);
  pDatierungLastYear = new TEdit(this, IDC_RF_D_LAST_YEAR, 255);
  pErfassung = new TCheckBox(this, IDC_RF_ERFASSUNG, 0);
  pErfassungFirstDay = new TEdit(this, IDC_RF_E_FIRST_DAY, 255);
  pErfassungFirstMonth = new TEdit(this, IDC_RF_E_FIRST_MONTH, 255);
  pErfassungFirstYear = new TEdit(this, IDC_RF_E_FIRST_YEAR, 255);
  pErfassungHeute = new TButton(this, IDC_RF_E_HEUTE);
  pErfassungLastDay = new TEdit(this, IDC_RF_E_LAST_DAY, 255);
  pErfassungLastMonth = new TEdit(this, IDC_RF_E_LAST_MONTH, 255);
  pErfassungLastYear = new TEdit(this, IDC_RF_E_LAST_YEAR, 255);
  pErfassungUebernehmen = new TButton(this, IDC_RF_E_UEBERNEHMEN);
  pOk = new TButton(this, IDOK);

  SetTransferBuffer(&RechnungsFilerData);
//{{RechnungsFilerXFER_USE_END}}

  // INSERT>> Your constructor code here.

  _data_set_mode = false;
}


RechnungsFiler::~RechnungsFiler()
{
  Destroy(IDCANCEL);

  // INSERT>> Your destructor code here.

}


void RechnungsFiler::FillForm()
{
   char text[256];

   _data_set_mode = true;
   if(_use_datierung) pDatierung->SetCheck(BF_CHECKED);
   else pDatierung->SetCheck(BF_UNCHECKED);

   if(_use_datierung)
   {
		pDatierungFirstDay->EnableWindow(true);
   	pDatierungFirstMonth->EnableWindow(true);
   	pDatierungFirstYear->EnableWindow(true);

   	pDatierungLastDay->EnableWindow(true);
   	pDatierungLastMonth->EnableWindow(true);
   	pDatierungLastYear->EnableWindow(true);
   } // if
   else
   {
   	pDatierungFirstDay->EnableWindow(false);
   	pDatierungFirstMonth->EnableWindow(false);
   	pDatierungFirstYear->EnableWindow(false);

   	pDatierungLastDay->EnableWindow(false);
   	pDatierungLastMonth->EnableWindow(false);
   	pDatierungLastYear->EnableWindow(false);
   } // else

   if(_use_erfassung)
   {
      pErfassung->SetCheck(BF_CHECKED);

      pErfassungFirstDay->EnableWindow(true);
      pErfassungFirstMonth->EnableWindow(true);
      pErfassungFirstYear->EnableWindow(true);

      pErfassungLastDay->EnableWindow(true);
      pErfassungLastMonth->EnableWindow(true);
      pErfassungLastYear->EnableWindow(true);
   } // if
   else
   {
      pErfassung->SetCheck(BF_UNCHECKED);

      pErfassungFirstDay->EnableWindow(false);
      pErfassungFirstMonth->EnableWindow(false);
      pErfassungFirstYear->EnableWindow(false);

      pErfassungLastDay->EnableWindow(false);
      pErfassungLastMonth->EnableWindow(false);
      pErfassungLastYear->EnableWindow(false);
   } // else

   if(!_use_datierung && !_use_erfassung)
    pOk->EnableWindow(false);
   else
    pOk->EnableWindow(true);

   if((_datierung_first.Year() > 1970) && (_datierung_first.Year() < 10000))
   {
      sprintf(text, "%d", _datierung_first.DayOfMonth());
      pDatierungFirstDay->SetText(text);
      sprintf(text, "%d", _datierung_first.Month());
      pDatierungFirstMonth->SetText(text);
      sprintf(text, "%d", _datierung_first.Year());
      pDatierungFirstYear->SetText(text);
   } // if
   else
   {
      pDatierungFirstDay->SetText("");
      pDatierungFirstMonth->SetText("");
      pDatierungFirstYear->SetText("");
   } // else

   if((_datierung_last.Year() > 1970) && (_datierung_last.Year() < 10000))
   {
      sprintf(text, "%d", _datierung_last.DayOfMonth());
      pDatierungLastDay->SetText(text);
      sprintf(text, "%d", _datierung_last.Month());
      pDatierungLastMonth->SetText(text);
      sprintf(text, "%d", _datierung_last.Year());
      pDatierungLastYear->SetText(text);
   } // if
   else
   {
      pDatierungLastDay->SetText("");
      pDatierungLastMonth->SetText("");
      pDatierungLastYear->SetText("");
   } // else

   if((_erfassung_first.Year() > 1970) && (_erfassung_first.Year() < 10000))
	{
      sprintf(text, "%d", _erfassung_first.DayOfMonth());
      pErfassungFirstDay->SetText(text);
      sprintf(text, "%d", _erfassung_first.Month());
      pErfassungFirstMonth->SetText(text);
      sprintf(text, "%d", _erfassung_first.Year());
      pErfassungFirstYear->SetText(text);
   } // if
   else
   {
      pErfassungFirstDay->SetText("");
      pErfassungFirstMonth->SetText("");
      pErfassungFirstYear->SetText("");
   } // else

   if((_erfassung_last.Year() > 1970) && (_erfassung_last.Year() < 10000))
	{
      sprintf(text, "%d", _erfassung_last.DayOfMonth());
      pErfassungLastDay->SetText(text);
      sprintf(text, "%d", _erfassung_last.Month());
      pErfassungLastMonth->SetText(text);
      sprintf(text, "%d", _erfassung_last.Year());
      pErfassungLastYear->SetText(text);
   } //
   else
   {
      pErfassungLastDay->SetText("");
      pErfassungLastMonth->SetText("");
      pErfassungLastYear->SetText("");
   } // else
   _data_set_mode = false;
} // RechnungsFiler::FillForm


void RechnungsFiler::FillRechnungsListe(GenericList<Rechnung>& RechnungsListe, bool _nur_offene)
{
	_p_module_broker->GetRechnungsVerwaltungPtr()->GetZeitraumliste(RechnungsListe, _erfassung_first, _erfassung_last, _datierung_first, _datierung_last, _use_erfassung, _use_datierung, _nur_offene);
} // RechnungsFiler::FillRechnungsListe


void RechnungsFiler::CmErfassung()
{
  // INSERT>> Your code here.

  _use_erfassung = !_use_erfassung;
  FillForm();
}


void RechnungsFiler::CmDatierung()
{
  // INSERT>> Your code here.

  _use_datierung = !_use_datierung;
  FillForm();
}


void RechnungsFiler::CmUebernehmen()
{
  // INSERT>> Your code here.

  _erfassung_first = _datierung_first;
  _erfassung_last = _datierung_last;
  FillForm();
}


void RechnungsFiler::CmErfassungHeute()
{
  // INSERT>> Your code here.

  _erfassung_last = _erfassung_first = TDate();
  _erfassung_first -= 21;
  FillForm();
}


void RechnungsFiler::CmDatierungHeute()
{
  // INSERT>> Your code here.

  _datierung_last = _datierung_first = TDate();
  _datierung_first -= 21;
  FillForm();
}


void RechnungsFiler::Cm_Ok()
{
  // INSERT>> Your code here.

  ENChange();
  TDialog::CmOk();
}


void RechnungsFiler::ENChange()
{
  // INSERT>> Your code here.

  char text[256];
  int  tag, monat, jahr;

  if(!_data_set_mode)
  {
     if(pDatierung->GetCheck() == BF_CHECKED) _use_datierung = true;
     else _use_datierung = false;
     if(pErfassung->GetCheck() == BF_CHECKED) _use_erfassung = true;
     else _use_erfassung = false;

     pDatierungFirstDay->GetText(text, 255); tag = atoi(text);
     pDatierungFirstMonth->GetText(text, 255); monat = atoi(text);
     pDatierungFirstYear->GetText(text, 255); jahr = atoi(text);
     _datierung_first = TDate(tag, monat, jahr);

     pDatierungLastDay->GetText(text, 255); tag = atoi(text);
     pDatierungLastMonth->GetText(text, 255); monat = atoi(text);
     pDatierungLastYear->GetText(text, 255); jahr = atoi(text);
     _datierung_last = TDate(tag, monat, jahr);

     pErfassungFirstDay->GetText(text, 255); tag = atoi(text);
     pErfassungFirstMonth->GetText(text, 255); monat = atoi(text);
     pErfassungFirstYear->GetText(text, 255); jahr = atoi(text);
     _erfassung_first = TDate(tag, monat, jahr);

     pErfassungLastDay->GetText(text, 255); tag = atoi(text);
     pErfassungLastMonth->GetText(text, 255); monat = atoi(text);
     pErfassungLastYear->GetText(text, 255); jahr = atoi(text);
     _erfassung_last = TDate(tag, monat, jahr);
  } // if
}

void RechnungsFiler::SetupWindow()
{
  TDialog::SetupWindow();

  // INSERT>> Your code here.

  FillForm();
}
