//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         rechnungsfiler.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for RechnungsFiler (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(rechnungsfiler_h)              // Sentry, use file only if it's not already included.
#define rechnungsfiler_h

#include <owl/dialog.h>


#include "weinadminapp.rh"            // Definition of all resources.
#include "weinadminapp.h"

#include <pbk/rechnung/rechnung.h>
#include <pbk/modulebroker/modulebroker.h>

#include <classlib/date.h>
#include <owl/commctrl.h>
#include <owl/button.h>
#include <owl/edit.h>
#include <owl/checkbox.h>


//{{TDialog = RechnungsFiler}}
struct RechnungsFilerXfer {
//{{RechnungsFilerXFER_DATA}}
    uint    pDatierung;
    char    pDatierungFirstDay[ 255 ];
    char    pDatierungFirstMonth[ 255 ];
    char    pDatierungFirstYear[ 255 ];
    char    pDatierungLastDay[ 255 ];
    char    pDatierungLastMonth[ 255 ];
    char    pDatierungLastYear[ 255 ];
    uint    pErfassung;
    char    pErfassungFirstDay[ 255 ];
    char    pErfassungFirstMonth[ 255 ];
    char    pErfassungFirstYear[ 255 ];
    char    pErfassungLastDay[ 255 ];
    char    pErfassungLastMonth[ 255 ];
    char    pErfassungLastYear[ 255 ];
//{{RechnungsFilerXFER_DATA_END}}
};

class RechnungsFiler : public TDialog, RechnungsServer {
  protected:
	 TDate& 			_erfassung_first;
	 TDate& 			_erfassung_last;
    TDate& 			_datierung_first;
    TDate& 			_datierung_last;
    bool&  			_use_erfassung, &_use_datierung;
    bool	   		_data_set_mode;
	 ModuleBroker* _p_module_broker;

  public:
    RechnungsFiler(TWindow* parent, TDate&, TDate&, TDate&, TDate&, bool&, bool&, ModuleBroker*, TResId resId = IDD_RECHNUNGSFILTER, TModule* module = 0);
    virtual ~RechnungsFiler();

    void FillRechnungsListe(GenericList<Rechnung>&, bool);

  protected:
	 void FillForm();

//{{RechnungsFilerXFER_DEF}}
  protected:
    TCheckBox* pDatierung;
    TEdit* pDatierungFirstDay;
    TEdit* pDatierungFirstMonth;
    TEdit* pDatierungFirstYear;
    TButton* pDatierungHeute;
    TEdit* pDatierungLastDay;
    TEdit* pDatierungLastMonth;
    TEdit* pDatierungLastYear;
    TCheckBox* pErfassung;
    TEdit* pErfassungFirstDay;
    TEdit* pErfassungFirstMonth;
    TEdit* pErfassungFirstYear;
    TButton* pErfassungHeute;
    TEdit* pErfassungLastDay;
    TEdit* pErfassungLastMonth;
    TEdit* pErfassungLastYear;
    TButton* pErfassungUebernehmen;
    TButton* pOk;

//{{RechnungsFilerXFER_DEF_END}}

//{{RechnungsFilerVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{RechnungsFilerVIRTUAL_END}}

//{{RechnungsFilerRSP_TBL_BEGIN}}
  protected:
    void CmErfassung();
    void CmDatierung();
    void CmUebernehmen();
    void CmErfassungHeute();
    void CmDatierungHeute();
    void Cm_Ok();
    void ENChange();
//{{RechnungsFilerRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(RechnungsFiler);
};    //{{RechnungsFiler}}


#endif  // rechnungsfiler_h sentry.

