//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         rechnungsliste.h
//  AUTIDC_STOREOR:       Thomas IDC_STOREaenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for RechnungsListe (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(rechnungsliste_h)              // Sentry, use file only if it's not already included.
#define rechnungsliste_h

#include <owl/dialog.h>


#include <owl/button.h>
#include <owl/commctrl.h>
#include "weinadminapp.h"
#include "weinadminapp.rh"            // Definition of all resources.
#include <owl/listwind.h>
#include <owl/edit.h>
#include <owl/checkbox.h>

#include <pbk/modulebroker/modulebroker.h>


//{{TDialog = RechnungsListe}}
struct RechnungsListeXfer {
//{{RechnungsListeXFER_DATA}}
    uint    pBeglichen;
    char    pBemerkung[ 255 ];
    char    pBetragEingegangen[ 255 ];
    char    pBetragGesamt[ 255 ];
    char    pDatumJahr[ 255 ];
    char    pDatumMonat[ 255 ];
    char    pDatumTag[ 255 ];
    char    pKartons[ 255 ];
    char    pNummer[ 255 ];
    char    pSteigen[ 255 ];
    uint    pNurOffene;
//{{RechnungsListeXFER_DATA_END}}
};

class RechnungsListe : public TDialog {
  protected:
    enum Mode {KUNDENLISTE, ZEITLISTE} _mode;

    GenericList<Rechnung>* _p_liste_rechnungen;
    Rechnung*				   _p_current_rechnung;
    Kunde*					   _p_current_kunde;
    ModuleBroker*          _p_module_broker;   
    RechnungsServer*       _p_rechnungs_server;
    bool							_nur_offene;
    bool							_dirty; 				   // Daten verndert?

  public:
    RechnungsListe(TWindow* parent, RechnungsServer* pRechnungsServer, ModuleBroker*, Kunde* = NULL, TResId resId = IDD_RECHNUNGSLISTE, TModule* module = 0);
    virtual ~RechnungsListe();

	static void CmSysDrucken(TWindow*, ModuleBroker*, Rechnung*, bool, bool, bool, bool);

  protected:
    void FillTabelle();


//{{RechnungsListeXFER_DEF}}
  protected:
    TCheckBox* pBeglichen;
    TEdit* pBemerkung;
    TEdit* pBetragEingegangen;
    TEdit* pBetragGesamt;
    TEdit* pDatumJahr;
    TEdit* pDatumMonat;
    TEdit* pDatumTag;
    TEdit* pKartons;
    TEdit* pNummer;
    TEdit* pSteigen;
    TListWindow* pTabelle;
    TButton* pBearbeiten;
    TCheckBox* pNurOffene;
    TButton* pDuplicate;
    TButton* pDrucken;
    TButton* pLoeschen;

//{{RechnungsListeXFER_DEF_END}}

//{{RechnungsListeVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{RechnungsListeVIRTUAL_END}}

//{{RechnungsListeRSP_TBL_BEGIN}}
  protected:
    void LVNGetdispinfo(TLwDispInfoNotify& lwdin);
    bool LVNItemchanging(TLwNotify& lwn);
    void CmBearbeiten();
    void CmHeute();
    void CmLeer();
    void CmStore();
    void CmDrucken();
    void CmLoeschen();
    void CmNurOffene();
    void CmDuplicateRechnung();
    void CmChangeEingegangen();
    void CmDataChange();
//{{RechnungsListeRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(RechnungsListe);
};    //{{RechnungsListe}}


#endif  // rechnungsliste_h sentry.

