//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         rechnungsnummer.cpp
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of RechnungsNummer (TDialog).
//
//----------------------------------------------------------------------------
#include <owl/pch.h>

#include "rechnungsnummer.h"
#include "rechnungsliste.h"


//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(RechnungsNummer, TDialog)
//{{RechnungsNummerRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDOK, CmOk),
  EV_BN_CLICKED(IDCANCEL, CmCancel),
  EV_BN_CLICKED(IDC_REBN_USEBETRAG, CmUseBetrag),
  EV_BN_CLICKED(IDC_REBN_USENUMMER, CmUseBetrag),
//{{RechnungsNummerRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{RechnungsNummer Implementation}}


static RechnungsNummerXfer RechnungsNummerData;

RechnungsNummer::RechnungsNummer(TWindow* parent, ModuleBroker* pModuleBroker, TResId resId, TModule* module)
:
    TDialog(parent, resId, module), _p_module_broker(pModuleBroker)
{
//{{RechnungsNummerXFER_USE}}
  pUseBetrag = new TRadioButton(this, IDC_REBN_USEBETRAG, 0);
  pAbweichung = new TEdit(this, IDC_REBN_ABWEICHUNG, 255);
  pBetrag = new TEdit(this, IDC_REBN_BETRAG, 255);
  pNummer = new TEdit(this, IDC_REBN_NUMMER, 255);
  pUseNummer = new TRadioButton(this, IDC_REBN_USENUMMER, 0);

  SetTransferBuffer(&RechnungsNummerData);
//{{RechnungsNummerXFER_USE_END}}

  // INSERT>> Your constructor code here.

}


RechnungsNummer::~RechnungsNummer()
{
  Destroy(IDCANCEL);

  // INSERT>> Your destructor code here.

}


void RechnungsNummer::CmOk()
{
	// INSERT>> Your code here.

   char  text[100];

   if(pUseBetrag->GetCheck() == BF_CHECKED)
   {
		pBetrag->GetText(text, 99); _betrag = atof(text);
		pAbweichung->GetText(text, 99); _abweichung = atof(text);

		_nummer = -1;
   } // if
   else
   {
   	pNummer->GetText(text, 99); _nummer = atof(text);

      _betrag = _abweichung = -1.0;
   } // else

   RechnungsListe LocalRechnungsListe(this, this, _p_module_broker);
   LocalRechnungsListe.Execute();
   Destroy();
}


void RechnungsNummer::CmCancel()
{
	// INSERT>> Your code here.

   Destroy();
}



void RechnungsNummer::SetupWindow()
{
	TDialog::SetupWindow();

	// INSERT>> Your code here.

   pUseNummer->SetCheck(BF_CHECKED);
   _nummer = 0;

   if(pUseBetrag->GetCheck() == BF_CHECKED)
   {
		pAbweichung->EnableWindow(true);
		pBetrag->EnableWindow(true);
		pNummer->EnableWindow(false);
   } // if
   else
   {
		pAbweichung->EnableWindow(false);
		pBetrag->EnableWindow(false);
		pNummer->EnableWindow(true);
   } // else
}


void RechnungsNummer::CmUseBetrag()
{
	// INSERT>> Your code here.

   if(pUseBetrag->GetCheck() == BF_CHECKED)
   {
		pAbweichung->EnableWindow(true);
		pBetrag->EnableWindow(true);
		pNummer->EnableWindow(false);
   } // if
   else
   {
		pAbweichung->EnableWindow(false);
		pBetrag->EnableWindow(false);
		pNummer->EnableWindow(true);
   } // else
}


void RechnungsNummer::FillRechnungsListe(GenericList<Rechnung>& RechnungsListe, bool _nur_offene)
{
   _p_module_broker->GetRechnungsVerwaltungPtr()->GetListeByNummerOrBetrag(_nummer, _betrag, _abweichung, RechnungsListe);
} // RechnungsNummer::FillRechnungsListe
