//----------------------------------------------------------------------------
//  Project weinadmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         rechnungsnummer.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for RechnungsNummer (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(rechnungsnummer_h)              // Sentry, use file only if it's not already included.
#define rechnungsnummer_h

#include <owl/dialog.h>


#include <owl/edit.h>
#include <owl/radiobut.h>
#include <owl/commctrl.h>
#include "weinadminapp.rh"            // Definition of all resources.

#include <pbk/modulebroker/modulebroker.h>
#include <pbk/rechnung/rechnung.h>

//{{TDialog = RechnungsNummer}}
struct RechnungsNummerXfer {
//{{RechnungsNummerXFER_DATA}}
    uint    pUseBetrag;
    char    pAbweichung[ 255 ];
    char    pBetrag[ 255 ];
    char    pNummer[ 255 ];
    uint    pUseNummer;
//{{RechnungsNummerXFER_DATA_END}}
};

class RechnungsNummer : public TDialog, RechnungsServer {
  protected:
	 ModuleBroker* _p_module_broker;
    float			_betrag, _abweichung;
    long				_nummer;

  public:
    RechnungsNummer(TWindow* parent, ModuleBroker*, TResId resId = IDD_RECHNUNGSNUMMER, TModule* module = 0);
    virtual ~RechnungsNummer();

    void FillRechnungsListe(GenericList<Rechnung>&, bool);

//{{RechnungsNummerVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{RechnungsNummerVIRTUAL_END}}

//{{RechnungsNummerRSP_TBL_BEGIN}}
  protected:
    void CmOk();
    void CmCancel();
    void CmUseBetrag();
//{{RechnungsNummerRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(RechnungsNummer);

//{{RechnungsNummerXFER_DEF}}
  protected:
    TRadioButton* pUseBetrag;
    TEdit* pAbweichung;
    TEdit* pBetrag;
    TEdit* pNummer;
    TRadioButton* pUseNummer;

//{{RechnungsNummerXFER_DEF_END}}
};    //{{RechnungsNummer}}


#endif  // rechnungsnummer_h sentry.

