//----------------------------------------------------------------------------
//  Project WeinAdmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    WeinAdmin Application
//  FILE:         weinadminaboutdlg.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TWeinAdminAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(weinadminaboutdlg_h)              // Sentry, use file only if it's not already included.
#define weinadminaboutdlg_h

#include <owl/static.h>

#include "weinadminapp.rh"                  // Definition of all resources.


//{{TDialog = TWeinAdminAboutDlg}}
class TWeinAdminAboutDlg : public TDialog {
  public:
    TWeinAdminAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TWeinAdminAboutDlg();

//{{TWeinAdminAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TWeinAdminAboutDlgVIRTUAL_END}}
};    //{{TWeinAdminAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // weinadminaboutdlg_h sentry.
