//----------------------------------------------------------------------------
//  Project WeinAdmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    WeinAdmin Application
//  FILE:         weinadminapp.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TWeinAdminApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(weinadminapp_h)              // Sentry, use file only if it's not already included.
#define weinadminapp_h

#include <owl/controlb.h>
#include <owl/docking.h>


#include "weinadminapp.rh"            // Definition of all resources.

#include <pbk/kunde/kundenverwaltung.h>
#include <pbk/wein/weinlistenverwaltung.h>
#include <pbk/preis/preisverwaltung.h>
#include <pbk/rechnung/rechnungsverwaltung.h>
#include <pbk/geogruppe/geogruppe.h>
#include <pbk/logbuch/logbuch.h>
#include <pbk/modulebroker/modulebroker.h>
#include <pbk/customizer/customizer.h>
#include <pbk/merkzettelverwaltung/merkzettelverwaltung.h>

//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  protected:
    KundenVerwaltung*     _p_kunden_verwaltung;
    WeinlistenVerwaltung  _weinlisten_verwaltung;
	 PreisVerwaltung		  _preis_verwaltung;
	 PostenVerwaltung		  _posten_verwaltung;
    RechnungsVerwaltung   _rechnungs_verwaltung;
    GeoGruppe				  _geo_gruppe;
    LogBuch					  _log_buch;
    ModuleBroker	        _module_broker;
    Customizer				  _customizer;
    MerkzettelVerwaltung* _p_merkzettel_verwaltung;

  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//    KundenVerwaltung*     GetKundenVerwaltungPtr() {return &_kunden_verwaltung;};
//    WeinlistenVerwaltung* GetWeinlistenVerwaltungPtr() {return &_weinlisten_verwaltung;};
//	 PreisVerwaltung*		  GetPreisVerwaltungPtr() {return &_preis_verwaltung;};
//	 PostenVerwaltung*	  GetPostenVerwaltungPtr() {return &_posten_verwaltung;};
//    RechnungsVerwaltung*  GetRechnungsVerwaltungPtr() {return &_rechnungs_verwaltung;};
//    GeoGruppe*				  GetGeoGruppePtr() {return &_geo_gruppe;};
//    LogBuch*				  GetLogBuchPtr() {return &_log_buch;};

//{{TSDIDecFrameVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
    virtual bool ShowWindow(int cmdShow);
//{{TSDIDecFrameVIRTUAL_END}}

//{{TSDIDecFrameRSP_TBL_BEGIN}}
  protected:
    void CmAddkunde();
    void CmSearchkunde();
    void CmWeinEdit();
    void CmPreisedit();
    void CmAddRechnung();
    void CmFlaschencount();
    void CmKundenexport();
    void CmRecallrechnungen();
    void CmLoadDoc();
    void CmPreferences();
    void CmMerkzettel();
    void CmRecallReByNumber();
    void CmPreisExport();
    void EvSetFocus(HWND hWndLostFocus);
//{{TSDIDecFrameRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TSDIDecFrame);
};    //{{TSDIDecFrame}}


//{{TApplication = TWeinAdminApp}}
class TWeinAdminApp : public TApplication {
  private:

  private:
    void SetupSpeedBar(TDecoratedFrame* frame);

  public:
    TWeinAdminApp();
    virtual ~TWeinAdminApp();

    void CreateGadgets(TDockableControlBar* cb, bool server = false);
    THarbor*        ApxHarbor;

//{{TWeinAdminAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TWeinAdminAppVIRTUAL_END}}

//{{TWeinAdminAppRSP_TBL_BEGIN}}
  protected:
    void EvNewView(TView& view);
    void EvCloseView(TView& view);
    void CmHelpAbout();
    void CmRecallrechnungen();
//{{TWeinAdminAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TWeinAdminApp);
};    //{{TWeinAdminApp}}


#endif  // weinadminapp_h sentry.
