//----------------------------------------------------------------------------
//  Project WeinAdmin
//  
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    WeinAdmin Application
//  FILE:         weinadmindlgclient.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TWeinAdminDlgClient (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(weinadmindlgclient_h)              // Sentry, use file only if it's not already included.
#define weinadmindlgclient_h

#include <owl/docview.h>

#include "weinadminapp.rh"                  // Definition of all resources.


//{{TDialog = TWeinAdminDlgClient}}
class TWeinAdminDlgClient : public TDialog, public TView {
  public:
//  TWeinAdminDlgClient(TWindow* parent, TResId resId = IDD_CLIENT, TModule* module = 0);  //{{DIALOG_ASSOCIATION}}

    TWeinAdminDlgClient(TDocument& doc, TWindow* parent = 0);
    virtual ~TWeinAdminDlgClient();

    static const char far* StaticName() {return "Dialog View";}  // put in resource

    // Inherited virtuals from TView
    //
    const char far* GetViewName() {return StaticName();}
    TWindow* GetWindow() {return(TWindow*)this;}
    bool     SetDocTitle(const char far* docname, int index)
             { return TWindow::SetDocTitle(docname, index); }
  private:
    // Event handlers
    //
    bool     VnIsWindow(HWND hWnd)
             { return ((HWindow == hWnd) || IsChild(hWnd)); }

//{{TWeinAdminDlgClientVIRTUAL_BEGIN}}
  public:
    virtual bool CanClose();
//{{TWeinAdminDlgClientVIRTUAL_END}}

//{{TWeinAdminDlgClientRSP_TBL_BEGIN}}
  protected:
//{{TWeinAdminDlgClientRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TWeinAdminDlgClient);
};    //{{TWeinAdminDlgClient}}


#endif  // weinadmindlgclient_h sentry.
