//----------------------------------------------------------------------------
//  Project weinadmin
//
//  Copyright  1996. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    weinadmin.apx Application
//  FILE:         weinliste.h
//  AUTHOR:       Thomas Haenselmann
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for WeinListe (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(weinliste_h)              // Sentry, use file only if it's not already included.
#define weinliste_h

#include <owl/dialog.h>


#include <owl/groupbox.h>
#include <owl/static.h>
#include <owl/checkbox.h>
#include <owl/listbox.h>
#include <owl/combobox.h>
#include <owl/commctrl.h>
#include <owl/listwind.h>
#include <owl/edit.h>
#include <owl/button.h>
#include "weinadminapp.rh"            // Definition of all resources.

#include <pbk/kunde/kunde.h>
#include <pbk/modulebroker/modulebroker.h>
#include "pbk/rechnung/rechnung.h"

// #define IDC_STORE 200
// #define IDC_CLEAR 201
// #define IDC_PREISLISTE 202

//{{TDialog = WeinListe}}
struct WeinListeXfer {
//{{WeinListeXFER_DATA}}
    char    pBestand[ 255 ];
    char    pBestellmenge[ 255 ];
    char    pFuellmenge[ 255 ];
    char    pGewicht[ 255 ];
    char    pName[ 255 ];
    char    pNummer[ 255 ];
    char    pPreis[ 255 ];
    char    pBezeichnung[ 255 ];
    char    pPreisEU[ 255 ];
    uint    pFullList;
    char    pKartons[ 255 ];
    char    pRechnungsNr[ 255 ];
    char    pSteigen[ 255 ];
    char    pBetragGesamt[ 255 ];
    char    pBetragEingegangen[ 255 ];
    char    pDatumJahr[ 255 ];
    char    pDatumMonat[ 255 ];
    char    pDatumTag[ 255 ];
    char    pBemerkung[ 255 ];
    uint    pBeglichen;
    char    pTextRechnungsNr[ 255 ];
    char    pTextBemerkung[ 255 ];
    char    pTextBestellmenge[ 255 ];
    char    pTextBetrag[ 255 ];
    char    pTextDatum[ 255 ];
    char    pTextPreis[ 255 ];
    char    pTextPreisliste[ 255 ];
    char    pTextSteigen[ 255 ];
//{{WeinListeXFER_DATA_END}}
};

class WeinListe : public TDialog {
  public:
    enum Mode {WEINLISTE, PREISLISTE, BESTELLUNG};

  protected:
    ModuleBroker*			  _p_module_broker;
    Mode 					  _mode;
    Rechnung*				  _p_current_rechnung;
    Kunde*					  _p_current_kunde;
    bool						  _full_list, _neue_rechnung;
	 TComboBox*				  pPreisliste;
    TStatic					  *pBmpPreisListe, *pBmpWeinListe, *pBmpRechnungenEditieren, *pBmpRechnungListe;
    bool						  _dirty;
    
  public:
    WeinListe(TWindow* parent, ModuleBroker*, Mode, Kunde* = NULL,
    			  Rechnung* = NULL, bool = true, TResId resId = IDD_WEINLISTE, TModule* module = 0);
    virtual ~WeinListe();

//{{WeinListeXFER_DEF}}
  protected:
    TEdit* pBestand;
    TEdit* pBestellmenge;
    TEdit* pFuellmenge;
    TEdit* pGewicht;
    TEdit* pName;
    TEdit* pNummer;
    TEdit* pPreis;
    TListWindow* pTabelle;
    TEdit* pBezeichnung;
    TEdit* pPreisEU;
    TCheckBox* pFullList;
    TEdit* pKartons;
    TEdit* pRechnungsNr;
    TEdit* pSteigen;
    TEdit* pBetragGesamt;
    TEdit* pBetragEingegangen;
    TEdit* pDatumJahr;
    TEdit* pDatumMonat;
    TEdit* pDatumTag;
    TEdit* pBemerkung;
    TCheckBox* pBeglichen;
    TButton* pStorePosten;
    TButton* pStoreRechnung;
    TButton* pOk;
    TButton* pClearPosten;
    TButton* pZurueck;
    TButton* pHeute;
    TButton* pLeer;
    TStatic* pTextRechnungsNr;
    TStatic* pTextBemerkung;
    TStatic* pTextBestellmenge;
    TStatic* pTextBetrag;
    TStatic* pTextDatum;
    TStatic* pTextPreis;
    TStatic* pTextPreisliste;
    TStatic* pTextSteigen;

//{{WeinListeXFER_DEF_END}}

//{{WeinListeVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
    virtual bool CanClose();
//{{WeinListeVIRTUAL_END}}

  protected:
    void CBNSelChange();
    void CmDataChange();
    void UpdateBemerkung();

//{{WeinListeRSP_TBL_BEGIN}}
  protected:
    void ENChange();
    void LVNGetdispinfo(TLwDispInfoNotify& lwdin);
    void FillTabelle();
    bool LVNItemchanging(TLwNotify& lwn);
    void BNClicked();
    void LVNItemchanged(TLwNotify& lwn);
    void CmOk();
    void CmStore();
    void CmStoreRechnung();
    void CmClearPosten();
    void CmHeute();
    void CmLeer();
//{{WeinListeRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(WeinListe);
};    //{{WeinListe}}


#endif  // weinliste_h sentry.

