#ifndef _PrintRechnung_h
#define _PrintRechnung_h

#include <owl/dc.h>
#include <owl/printer.h>
#include <owl/framewin.h>
#include "pbk/kunde/kunde.h"
#include "pbk/rechnung/rechnung.h"
#include <pbk/modulebroker/modulebroker.h>

#define NO_POSTEN_PACKLISTE 		 15
#define NO_POSTEN_RECHNUNG  		 10
#define NO_POSTEN_RECHNUNG_INTERN 20

class PrintRechnung
{
	public:
   	enum Mode {PACKLISTE, RECHNUNG, RECHNUNG_INTERN} _mode;

	protected:
      class RechnungRenderer : public TPrintout
      {
      	protected:
         	PrintRechnung* _p_print_rechnung;

      	public:
         	RechnungRenderer(const char* pTitle, PrintRechnung*);

            void PrintPage(int, TRect&, unsigned);
            void GetDialogInfo(int& minPage, int& maxPage, int& selFromPage, int& selToPage);
            void SetBanding(bool b){Banding = b;}
            bool HasPage(int pageNumber){return (pageNumber <= _p_print_rechnung->_no_pages);}
      }; // class RechnungRenderer

      friend class RechnungRenderer;

     	Kunde*                _p_kunde;
      Rechnung*             _p_rechnung;
      ModuleBroker* 			 _p_module_broker;
      bool					    _pre_view;
      int					    _no_pages;
		RechnungRenderer*		 pBlatt;

      class PreViewWindow : public TFrameWindow
      {
      	protected:
         	PrintRechnung* _p_print_rechnung;
            bool				_size_set;

      	public:
         	PreViewWindow(TWindow*, PrintRechnung*);
         	~PreViewWindow() {delete _p_print_rechnung;};

				void Paint(TDC&, bool, TRect&);
				void EvSize(uint, TSize&);

				DECLARE_RESPONSE_TABLE(PreViewWindow);
      }; // PreViewWindow

      friend class PreViewWindow;

	public:
   	PrintRechnung(Mode, bool, ModuleBroker*, Kunde*, Rechnung*);
   	~PrintRechnung() {if(pBlatt != NULL) delete pBlatt;};

   	void RenderPage(TWindow*);

   protected:
   	void RenderPage(TDC&, int, TRect&);
}; // class PrintRechnung
#endif