#include <pbk/kunde/kunde.h>
#include <except.h>
#include <cstring.h>
#include <global/global.h>

Kunde::Kunde(const unsigned long nr)
{
	Init();

	_nr = nr;
   _erfassung_datum = TDate();
   _erfassung_zeit = TTime();

} // Kunde::Kunde

Kunde::~Kunde()
{
} // Kunde::~Kunde

void Kunde::Init()
{
	// Fllen der Strings mitz Leerzeichen, damit eine evtl. Kompimierung besser damit zurecht kommt

   strfill(_anrede, sizeof(_anrede));
   strfill(_vorname, sizeof(_vorname));
   strfill(_nachname, sizeof(_nachname));
   strfill(_strasse, sizeof(_strasse));
   strfill(_ort, sizeof(_ort));
   strfill(_telefon, sizeof(_telefon));
   strfill(_fax, sizeof(_fax));
   strfill(_email, sizeof(_email));
   strfill(_bemerkung, sizeof(_bemerkung));
   _plz = 0;
   _preisliste_index = _geogruppe_index = 0;

	_last_rechnung_index = -1;
} // Kunde::Init

Kunde& Kunde::operator=(const Kunde& kunde)
{
	_nr = kunde._nr;

	strcpy(_anrede, kunde.GetAnrede());
	strcpy(_vorname, kunde.GetVorname());
	strcpy(_nachname, kunde.GetNachname());
	strcpy(_strasse, kunde.GetStrasse());
   _plz = kunde.GetPLZ();
	strcpy(_ort, kunde.GetOrt());
	strcpy(_telefon, kunde.GetTelefon());
	strcpy(_fax, kunde.GetFax());
	strcpy(_email, kunde.GetEMail());
	strcpy(_bemerkung, kunde.GetBemerkung());
   _erfassung_datum = kunde.GetErfassungDatum();
   _erfassung_zeit = kunde.GetErfassungZeit();
   _preisliste_index = kunde.GetPreisliste();
   _geogruppe_index = kunde.GetGeoGruppe();
   _last_rechnung_index = kunde.GetLastRechnungIndex();

   return *this;
} // Kunde::operator=


bool Kunde::DoesMatch(const Kunde& kunde)
{
	if(strstr(GetNachname(), kunde.GetNachname()) == GetNachname())
		if(strstr(GetVorname(), kunde.GetVorname()) == GetVorname())
			if(strstr(GetStrasse(), kunde.GetStrasse()) == GetStrasse())
            if((kunde.GetPLZ() == 0) || (kunde.GetPLZ() == GetPLZ()))
               if(strstr(GetOrt(), kunde.GetOrt()) == GetOrt())
                  if(strstr(GetTelefon(), kunde.GetTelefon()) == GetTelefon())
                     if(strstr(GetFax(), kunde.GetFax()) == GetFax())
                        if(strstr(GetEMail(), kunde.GetEMail()) == GetEMail())
                           if(strstr(GetAnrede(), kunde.GetAnrede()) == GetAnrede())
                           	return true;

   return false;
} // Kunde::DoesMatch

void Kunde::Read(fstream& stream)
{
/*
	unsigned char LocalBuffer[900];
   unsigned char *buffer;

   buffer = LocalBuffer;

	size_t position = stream.tellg();
   stream.read(buffer, SizeOf());
   stream.seekg(position);

	memcpy((void*)(&_nr), buffer, sizeof(_nr)); buffer += sizeof(_nr);
	memcpy((void*)(&_anrede), buffer, sizeof(_anrede)); buffer += sizeof(_anrede);
	memcpy((void*)(&_vorname), buffer, sizeof(_vorname)); buffer += sizeof(_vorname);
	memcpy((void*)(&_nachname), buffer, sizeof(_nachname)); buffer += sizeof(_nachname);
	memcpy((void*)(&_strasse), buffer, sizeof(_strasse)); buffer += sizeof(_strasse);
	memcpy((void*)(&_plz), buffer, sizeof(_plz)); buffer += sizeof(_plz);
	memcpy((void*)(&_ort), buffer, sizeof(_ort)); buffer += sizeof(_ort);
	memcpy((void*)(&_telefon), buffer, sizeof(_telefon)); buffer += sizeof(_telefon);
	memcpy((void*)(&_fax), buffer, sizeof(_fax)); buffer += sizeof(_fax);
	memcpy((void*)(&_email), buffer, sizeof(_email)); buffer += sizeof(_email);
	memcpy((void*)(&_bemerkung), buffer, sizeof(_bemerkung)); buffer += sizeof(_bemerkung);
	memcpy((void*)(&_preisliste_index), buffer, sizeof(_preisliste_index)); buffer += sizeof(_preisliste_index);
	memcpy((void*)(&_geogruppe_index), buffer, sizeof(_geogruppe_index)); buffer += sizeof(_geogruppe_index);
	memcpy((void*)(&_erfassung_datum), buffer, sizeof(_erfassung_datum)); buffer += sizeof(_erfassung_datum);
	memcpy((void*)(&_erfassung_zeit), buffer, sizeof(_erfassung_zeit));
*/

	stream.read((char*)&_nr, sizeof(_nr));
	stream.read((char*)&_anrede, sizeof(_anrede));
	stream.read((char*)&_vorname, sizeof(_vorname));
	stream.read((char*)&_nachname, sizeof(_nachname));
	stream.read((char*)&_strasse, sizeof(_strasse));
	stream.read((char*)&_plz, sizeof(_plz));
	stream.read((char*)&_ort, sizeof(_ort));
	stream.read((char*)&_telefon, sizeof(_telefon));
	stream.read((char*)&_fax, sizeof(_fax));
	stream.read((char*)&_email, sizeof(_email));
	stream.read((char*)&_bemerkung, sizeof(_bemerkung));
	stream.read((char*)&_preisliste_index, sizeof(_preisliste_index));
	stream.read((char*)&_geogruppe_index, sizeof(_geogruppe_index));
	stream.read((char*)&_erfassung_datum, sizeof(_erfassung_datum));
	stream.read((char*)&_erfassung_zeit, sizeof(_erfassung_zeit));
	stream.read((char*)&_last_rechnung_index, sizeof(_last_rechnung_index));

//	stream.read((char*)this, SizeOf());
} // Kunde::Read

void Kunde::Write(fstream& stream) const
{
//	stream.write((char*)this, SizeOf());

	stream.write((char*)&_nr, sizeof(_nr));
	stream.write((char*)&_anrede, sizeof(_anrede));
	stream.write((char*)&_vorname, sizeof(_vorname));
	stream.write((char*)&_nachname, sizeof(_nachname));
	stream.write((char*)&_strasse, sizeof(_strasse));
	stream.write((char*)&_plz, sizeof(_plz));
	stream.write((char*)&_ort, sizeof(_ort));
	stream.write((char*)&_telefon, sizeof(_telefon));
	stream.write((char*)&_fax, sizeof(_fax));
	stream.write((char*)&_email, sizeof(_email));
	stream.write((char*)&_bemerkung, sizeof(_bemerkung));
	stream.write((char*)&_preisliste_index, sizeof(_preisliste_index));
	stream.write((char*)&_geogruppe_index, sizeof(_geogruppe_index));
	stream.write((char*)&_erfassung_datum, sizeof(_erfassung_datum));
	stream.write((char*)&_erfassung_zeit, sizeof(_erfassung_zeit));
	stream.write((char*)&_last_rechnung_index, sizeof(_last_rechnung_index ));
} // Kunde::Write
