#ifndef _KundenVerwaltung_h
#define _KundenVerwaltung_h

#include <pbk/kunde/kunde.h>
#include <pbk/logbuch/logbuch.h>
#include <list/list.h>
#include <except.h>
#include <dir.h>

class KundenVerwaltung
{
	private:
      static unsigned long _last_kunden_nr;

	protected:
      LogBuch*				 _p_log_buch;
	   GenericList<Kunde> _kunden_liste;

      long					 _kunde_found_index;
      Kunde					 _search_kunde;

	public:
   	KundenVerwaltung(const char*);
   	~KundenVerwaltung();

		void 			 SetLogBuchPtr(LogBuch* pLogBuch) {_p_log_buch = pLogBuch;};
		Kunde*		 operator[](const unsigned long);
      void 			 Add(Kunde&) throw(xmsg);
		void 			 Remove(const unsigned long);
      void 			 Update(const Kunde&);
      unsigned int Search(const Kunde&, GenericList<Kunde>* = NULL);
      bool			 GetNextMatch(Kunde&);
		void 			 ReadPascalData();
		void 	       ReadCSVData();
      void			 ExportAsCSV(fstream&, bool, bool, long, long, long);
      void         FindOrt(const long, char*);

   protected:
      unsigned long GetNextKundenNr();
		void 	        GetNextString(char*, char*&);
      void          DevideFirstLastName(char*, char*, char*);
		bool          AtInString(char*);
}; // class KundenVerwaltung
#endif