#ifndef _PostenVerwaltung_h
#define _PostenVerwaltung_h

#include <except.h>
#include <cstring.h>
#include <fstream.h>
#include <dir.h>

#include "pbk/wein/weinlistenverwaltung.h"
#include "pbk/logbuch/logbuch.h"

#define MAX_CACHE_ENTRIES 100000

class PostenVerwaltung
{
	public:
   	class Posten
      {
      	public:
				unsigned long _wein_nr;
         	unsigned long _rechnung_nr;
            float			  _dm_preis;
            float			  _euro_preis;
            short			  _anzahl;
            long			  _prev_posten;

         public:
         	Posten() {};
         	Posten(const unsigned long rechnung_nr, const unsigned long wein_nr, const float DMPreis, const float EuroPreis, const short anzahl) : _rechnung_nr(rechnung_nr), _wein_nr(wein_nr), _dm_preis(DMPreis), _euro_preis(EuroPreis), _anzahl(anzahl) {};

            static size_t SizeOf() {return sizeof(Posten);};

            void Read(fstream&);
            void Write(fstream&) const;
      }; // class Posten

	protected:
		class WeinlistenVerwaltung* _p_weinlisten_verwaltung;
		class RechnungsVerwaltung*  _p_rechnungs_verwaltung;
      LogBuch*				          _p_log_buch;
		char		                   _filename[MAXDIR];
		unsigned long               _no_posten;

	public:
   	PostenVerwaltung(const char*);
   	~PostenVerwaltung();

      void 						 SetWeinlistenVerwaltungPtr(WeinlistenVerwaltung*);
      void 						 SetRechnungsVerwaltungPtr(RechnungsVerwaltung*);
		void 						 SetLogBuchPtr(LogBuch* pLogBuch) {_p_log_buch = pLogBuch;};
		RechnungsVerwaltung*  GetRechnungsVerwaltungPtr() {return _p_rechnungs_verwaltung;};
		WeinlistenVerwaltung* GetWeinlistenVerwaltungPtr() {return _p_weinlisten_verwaltung;};
      long 						 Add(class Rechnung*, unsigned long, const float, const float, const short, const unsigned long);
      long 						 Add(class Rechnung*, Posten&);
		void 						 Update(Posten&, long) throw(xmsg);
		bool 						 GetPosten(Posten&, long&, unsigned long) throw(xmsg);
}; // class PostenVerwaltung
#endif