/*

- Das Durchlaufen der Posten bis zum ersten ist so fr groe Datenmengen nicht haltbar

*/

#include <pbk/rechnung/rechnung.h>
#include <pbk/rechnung/rechnungsverwaltung.h>
#include <pbk/kunde/kunde.h>
#include <pbk/kunde/kundenverwaltung.h>
#include <global/global.h>

#include <cstring.h>

Rechnung::Rechnung(ModuleBroker* pModuleBroker, unsigned long nr, unsigned long nr_extern, unsigned long kunde_nr)
						 : _nr(nr), _nr_extern(nr_extern), _kunde_nr(kunde_nr), _p_module_broker(pModuleBroker), _posten_cache()
{
	Kunde* p_kunde;

	_erfasst_datum = TDate();
   _erfasst_zeit = TTime();

	_kisten = _kartons = 0;
	_datum = TDate(0, 0);
	_betrag_eingegangen = 0.0;
	_beglichen = false;
	_posten_cache_valid = false;

   strfill(_bemerkung, sizeof(_bemerkung));
	_last_posten = _prev_kunde_rechnung = -1;
	if((_p_module_broker) && (_p_module_broker->GetKundenVerwaltungPtr()))
		p_kunde = (*(_p_module_broker->GetKundenVerwaltungPtr()))[_kunde_nr];
   else p_kunde = NULL;

   if(p_kunde)
	{
   	_prev_kunde_rechnung = p_kunde->GetLastRechnungIndex();
      p_kunde->SetLastRechnungIndex(nr);
   } // if
} // Rechnung::Rechnung

float	Rechnung::GetBetragGesamt(bool DM)
{
   PostenVerwaltung::Posten posten;
	float 			  		    result = 0.0;
   long							 index;

   ResetPostenCursor(index);
   while(GetNextPosten(posten, index))
   {
   	if(DM) result += posten._dm_preis*(float)posten._anzahl;
      else result += posten._euro_preis*(float)posten._anzahl;
   } // while

   return result;
} // Rechnung::GetBetragGesamt

long Rechnung::GetGewicht()
{
   PostenVerwaltung::Posten posten;
	long 			  		    	 result = 0;
   long							 index;

   ResetPostenCursor(index);
   while(GetNextPosten(posten, index))
   	result += (long)((*(_p_module_broker->GetPostenVerwaltungPtr()->GetWeinlistenVerwaltungPtr()))[posten._wein_nr]->GetGewicht())*(long)posten._anzahl;

   return result;
} // Rechnung::GetGewicht

int Rechnung::GetNoPosten()
{
	int  							 no_posten = 0;
   long 							 index;
   PostenVerwaltung::Posten posten;

   ResetPostenCursor(index);
   while(GetNextPosten(posten, index))
		no_posten++;

   return no_posten;
} // Rechnung::GetNoPosten

void Rechnung::AddPosten(const unsigned long wein_nr, const float DMPreis, const float EuroPreis, short anzahl)
{
   PostenVerwaltung::Posten posten(GetNr(), wein_nr, DMPreis, EuroPreis, anzahl);
   long 							 index;

	if(!(*this)[wein_nr])
	{
	 	index = _p_module_broker->GetPostenVerwaltungPtr()->Add(this, posten);
	   _posten_cache.Add(posten);

      // Die Posten dieser Rechnung knnen nun vor _last_posten in der Posten-Datei gesucht werden

		if(_last_posten < index) _last_posten = index;

      // Wenn ein neuer Posten hinzugekomme ist, so mu auch die Rechnung
      // gespeichert werden, da nun der letzte Index verndert wurde

		(_p_module_broker->GetPostenVerwaltungPtr()->GetRechnungsVerwaltungPtr())->UpdateRechnung(this);
   } // if
   else
	{
   	_p_module_broker->GetPostenVerwaltungPtr()->Update(posten, _last_posten);
      _posten_cache_valid = false;
   } // else
} // Rechnung::AddPosten

void Rechnung::ClearPosten(const unsigned long wein_nummer)
{
   PostenVerwaltung::Posten posten(GetNr(), wein_nummer, 0.0, 0.0, 0);

	if((*this)[wein_nummer])
	{
   	_p_module_broker->GetPostenVerwaltungPtr()->Update(posten, _last_posten);
      _posten_cache_valid = false;
   } // else
} // Rechnung::ClearPosten

// Den folgenden beiden Funktionen kann man einen eigenen Zeiger bergeben. Dies ist wichtig,
// da manchmal eine Rechnung in verschachtelten Schleifen bearbeitet wird.

void Rechnung::ResetPostenCursor(long& index)
{
	index = _last_posten; // es wurde noch kein Posten
} // Rechnung::ResetPostenCursor

bool Rechnung::GetNextPosten(PostenVerwaltung::Posten& posten, long& index)
{
   if(index >= 0)
   	if(_p_module_broker->GetPostenVerwaltungPtr()->GetPosten(posten, index, GetNr())) return true;

   return false;
} // Rechnung::GetNextPosten

PostenVerwaltung::Posten* Rechnung::operator[](unsigned long wein_index)
{
	PostenVerwaltung::Posten posten;
   long						    index;

	if(!_posten_cache_valid)
   {
   	_posten_cache.Empty();

   	ResetPostenCursor(index);
      while(GetNextPosten(posten, index))
			_posten_cache.Add(posten);

   	_posten_cache_valid = true;
   } // if

	for(int i = 0; i < _posten_cache.GetNoElements(); i++)
   {
   	if(_posten_cache[i]._wein_nr == wein_index)
      	return &_posten_cache[i];
   } // for

   return NULL;
} // Rechnung::operator[]

Rechnung& Rechnung::operator=(const Rechnung& rechnung)
{
	_nr = rechnung.GetNr();
	_nr_extern = rechnung.GetNrExtern();
	_kunde_nr = rechnung.GetKundeNr();
	_kisten = rechnung.GetKisten();
	_kartons = rechnung.GetKartons();
	_datum = rechnung.GetDatum();
	_betrag_eingegangen = rechnung.GetBetragEingegangen();
	_beglichen = rechnung.GetBeglichen();
	_erfasst_datum = rechnung._erfasst_datum;
	_erfasst_zeit = rechnung._erfasst_zeit;
	strcpy(_bemerkung, rechnung.GetBemerkung());
	_last_posten = rechnung._last_posten;
   _prev_kunde_rechnung = rechnung._prev_kunde_rechnung;

	_posten_cache_valid = false;
   _p_module_broker = rechnung._p_module_broker;
} // Rechnung::operator=

void Rechnung::Read(fstream& stream)
{
	stream.read((char*)&_nr, sizeof(_nr));
	stream.read((char*)&_nr_extern, sizeof(_nr_extern));
	stream.read((char*)&_kunde_nr, sizeof(_kunde_nr));
	stream.read((char*)&_kisten, sizeof(_kisten));
	stream.read((char*)&_kartons, sizeof(_kartons));
	stream.read((char*)&_datum, sizeof(_datum));
	stream.read((char*)&_betrag_eingegangen, sizeof(_betrag_eingegangen));
	stream.read((char*)&_beglichen, sizeof(_beglichen));
	stream.read((char*)&_erfasst_datum, sizeof(_erfasst_datum));
	stream.read((char*)&_erfasst_zeit, sizeof(_erfasst_zeit));
	stream.read((char*)_bemerkung, sizeof(_bemerkung));
	stream.read((char*)&_last_posten, sizeof(_last_posten));
	stream.read((char*)&_prev_kunde_rechnung, sizeof(_prev_kunde_rechnung));
} // Rechnung::Read

void Rechnung::Write(fstream& stream) const
{
	stream.write((char*)&_nr, sizeof(_nr));
	stream.write((char*)&_nr_extern, sizeof(_nr_extern));
	stream.write((char*)&_kunde_nr, sizeof(_kunde_nr));
	stream.write((char*)&_kisten, sizeof(_kisten));
	stream.write((char*)&_kartons, sizeof(_kartons));
	stream.write((char*)&_datum, sizeof(_datum));
	stream.write((char*)&_betrag_eingegangen, sizeof(_betrag_eingegangen));
	stream.write((char*)&_beglichen, sizeof(_beglichen));
	stream.write((char*)&_erfasst_datum, sizeof(_erfasst_datum));
	stream.write((char*)&_erfasst_zeit, sizeof(_erfasst_zeit));
	stream.write((char*)_bemerkung, sizeof(_bemerkung));
	stream.write((char*)&_last_posten, sizeof(_last_posten));
	stream.write((char*)&_prev_kunde_rechnung, sizeof(_prev_kunde_rechnung));
} // Rechnung::Write
