#ifndef _RechnungsVerwaltung_h
#define _RechnungsVerwaltung_h

#include <dir.h>
#include <list/list.h>

#include <pbk/rechnung/rechnung.h>
#include <pbk/modulebroker/modulebroker.h>

class RechnungsVerwaltung
{
	public:
   	class FlaschenPosten
      {
      	public:
         	long  _wein_nr;
            short _anzahl;

				FlaschenPosten() {};
            FlaschenPosten(const long wein_nr, short anzahl) : _wein_nr(wein_nr), _anzahl(anzahl) {};

            bool operator< (const FlaschenPosten posten) {return _wein_nr < posten._wein_nr;};
            bool operator> (const FlaschenPosten posten) {return _wein_nr > posten._wein_nr;};

         	// Dummy-Funktionen fr die Liste

            void Read(const fstream&) {};
            void Write(fstream&) const {};
            static size_t SizeOf() {return 0;};
      }; // class FlaschenPosten

      enum FlaschenExportType {WRITE_TXTLIST, WRITE_XLSLIST};

	protected:
		ModuleBroker* _p_module_broker;
   	unsigned long _last_rechnung_nr, _last_rechnung_nr_extern;
      Rechnung*	  _p_new_rechnung, *_p_current_rechnung;
      long			  _current_rechnung_pos;             // Pos. der _current_rechnung i.d. Datei
		bool			  _new_rechnung_valid;
      char			  _filename[MAXDIR];

	public:
   	RechnungsVerwaltung(const char*);
      ~RechnungsVerwaltung();

      void 			  SetModuleBrokerPtr(ModuleBroker*);
   	Rechnung* 	  AllocRechnung(unsigned long) throw(xmsg);
		void 		 	  StoreRechnung();
      Rechnung* 	  operator[](unsigned long);
      void 		 	  UpdateCurrentRechnung();
		void 			  UpdateRechnung(Rechnung*);
		void 			  DeleteRechnung(const unsigned long, bool);
		void 			  Duplicate(Rechnung*);
		void 			  GetListeByKunde(const unsigned long, GenericList<Rechnung>&, bool);
	   void 			  GetListeByNummerOrBetrag(const long, const float, const float, GenericList<Rechnung>&);
      void    		  GetZeitraumliste(GenericList<Rechnung>&, const TDate, const TDate, const TDate, const TDate,
      										 const bool, const bool, bool);
		void 			  ErzeugeFlaschenliste(GenericList<Rechnung>&, GenericSortableList<FlaschenPosten>&);

		void   		  ExportFlaschenListe(const char*, FlaschenExportType);

	protected:
      unsigned long GetNextRechnungNr() {return _last_rechnung_nr++;};
      unsigned long GetNextRechnungNrExtern() {return _last_rechnung_nr_extern++;};
}; // class RechnungsVerwaltung
#endif
