#include <pbk/wein/wein.h>
#include <global/global.h>

void Wein::Read(fstream& stream)
{
	stream.read((char*)&_nr, sizeof(_nr));
	stream.read((char*)&_name, sizeof(_name));
	stream.read((char*)&_bezeichnung, sizeof(_bezeichnung));
	stream.read((char*)&_fuellmenge, sizeof(_fuellmenge));
	stream.read((char*)&_gewicht, sizeof(_gewicht));
	stream.read((char*)&_bestand, sizeof(_bestand));
	stream.read((char*)&_versteckt, sizeof(_versteckt));
	stream.read((char*)&_erfasst_datum, sizeof(_erfasst_datum));
	stream.read((char*)&_erfasst_zeit, sizeof(_erfasst_zeit));
} // Wein::Read

void Wein::Write(fstream& stream) const
{
	stream.write((char*)&_nr, sizeof(_nr));
	stream.write((char*)&_name, sizeof(_name));
	stream.write((char*)&_bezeichnung, sizeof(_bezeichnung));
	stream.write((char*)&_fuellmenge, sizeof(_fuellmenge));
	stream.write((char*)&_gewicht, sizeof(_gewicht));
	stream.write((char*)&_bestand, sizeof(_bestand));
	stream.write((char*)&_versteckt, sizeof(_versteckt));
	stream.write((char*)&_erfasst_datum, sizeof(_erfasst_datum));
	stream.write((char*)&_erfasst_zeit, sizeof(_erfasst_zeit));
} // Wein::Write

Wein& Wein::operator=(const Wein& wein)
{
	_nr = wein.GetNr();
   strcpy(_name, wein.GetName());
   strcpy(_bezeichnung, wein.GetBezeichnung());
   strcpy(_fuellmenge, wein.GetFuellmenge());
   _gewicht = wein.GetGewicht();
   _bestand = wein.GetBestand();
	_versteckt = wein.GetVersteckt();
   _erfasst_datum = wein._erfasst_datum;
   _erfasst_zeit = wein._erfasst_zeit;
} // Wein::operator=

void Wein::Init()
{
	strfill(_name, sizeof(_name));
	strfill(_bezeichnung, sizeof(_bezeichnung));
	strfill(_fuellmenge, sizeof(_fuellmenge));
   _gewicht = 0;
   _bestand = 0;
	_versteckt = false;

	_erfasst_datum = TDate();
   _erfasst_zeit = TTime();
} // Wein::Init
