#ifndef _Wein_h
#define _Wein_h

#include <classlib/date.h>
#include <classlib/time.h>
#include <fstream.h>

#define WS_SIZE_NR			 sizeof(long)
#define WS_SIZE_NAME		    60
#define WS_SIZE_BEZEICHNUNG 60
#define WS_SIZE_FUELLMENGE  10
#define WS_SIZE_GEWICHT     sizeof(unsigned short)
#define WS_SIZE_BESTAND     sizeof(long)

class Wein
{
	protected:
   	long 				_nr;
   	char 				_name[WS_SIZE_NAME];
      char 				_bezeichnung[WS_SIZE_BEZEICHNUNG];
      char 				_fuellmenge[WS_SIZE_FUELLMENGE];
      unsigned short _gewicht; // Gewicht der Flasche in Gramm
      long				_bestand;
      bool				_versteckt;
      TDate				_erfasst_datum;
      TTime			   _erfasst_zeit;

   public:
   	Wein() {Init();};
   	Wein(const long nr) : _nr(nr) {Init();};

      Wein& operator=(const Wein&);
      bool  operator<(const Wein& wein) {return _nr < wein.GetNr();};
      bool  operator>(const Wein& wein) {return _nr > wein.GetNr();};

      const long   GetNr() const {return _nr;};
      const char*  GetName() const {return _name;};
      const char*  GetBezeichnung() const {return _bezeichnung;};
      const char*  GetFuellmenge() const {return _fuellmenge;};
      const long 	 GetGewicht() const {return _gewicht;};
      const long   GetBestand() const {return _bestand;};
      bool			 GetVersteckt() const {return _versteckt;};
      const TDate& GetErfasstDatum() const {return _erfasst_datum;};
      const TTime& GetErfasstZeit() const {return _erfasst_zeit;};

      void SetNr(const long nr) {_nr = nr;};
      void SetName(const char* pText) {strcpy(_name, pText);};
      void SetBezeichnung(const char* pText) {strcpy(_bezeichnung, pText);};
      void SetFuellmenge(const char* pText) {strcpy(_fuellmenge, pText);};
      void SetGewicht(const unsigned short gewicht) {_gewicht = gewicht;};
      void SetBestand(const long bestand) {_bestand = bestand;};
      void SetVersteckt(bool versteckt) {_versteckt = versteckt;};

      void AddBestand(const long delta) {_bestand += delta;};

   	void Read(fstream&);
      void Write(fstream&) const;

      static size_t SizeOf() {return sizeof(Wein);};

   protected:
   	void Init();
}; // class Wein
#endif
