/*

- Die Funktion Save() sollte so ausgelegt sein, da nur die vernderten Daten speichert werden

*/

#include <pbk/wein/weinlistenverwaltung.h>
#include <stdio.h>
#include <except.h>
#include <cstring.h>
#include <fstream.h>
#include <limits.h>

WeinlistenVerwaltung::WeinlistenVerwaltung(const char* filename) : _wein_liste(filename)
{
	_p_log_buch = NULL;
} // WeinlistenVerwaltung::WeinlistenVerwaltung

WeinlistenVerwaltung::~WeinlistenVerwaltung()
{
} // WeinlistenVerwaltung::~WeinlistenVerwaltung

Wein* WeinlistenVerwaltung::operator[](const long index)
{
   for(int i = 0; i < _wein_liste.GetNoElements(); i++)
   	if(_wein_liste[i].GetNr() == index) return &(_wein_liste[i]);

   // der Wein konnte nicht gefunden werden

   return NULL;
} // WeinlistenVerwaltung::operator[]

void WeinlistenVerwaltung::Add(const long index)
{
	if(!operator[](index))
   {
   	// Den Wein gibt es noch nicht, er mu zuerst erzeugt werden

      Wein tmp_wein(index);
      _wein_liste.Add(tmp_wein);
   } // if
} // WeinlistenVerwaltung::Add

void WeinlistenVerwaltung::AddBestand(const unsigned long wein_nummer, const long delta)
{
	if(wein_nummer == ULONG_MAX) return;

	Wein* p_wein = (*this)[wein_nummer];

   if(p_wein)
   	p_wein->AddBestand(delta);
} // WeinlistenVerwaltung::AddBestand

void WeinlistenVerwaltung::ReadPascalFile()
{
	Wein   		  tmp_wein;
   char   		  text[300];
   unsigned char string_size;
   string 		  my_str;
   short		     gewicht;

	ofstream kill_stream("daten/weinliste.dat", ios::out|ios::binary);
   kill_stream.close();
   _wein_liste.Empty();

	ifstream stream("daten_alt/wl", ios::in|ios::binary);
   stream.width(1);

   for(long i = 0; i < 999; i++)
   {
		stream.seekg((i-0)*(61*2+11+2), ios::beg);
      stream.read(text, 61); string_size = (unsigned char)(text[0]);
      if(string_size > 59) string_size = 59;
      text[string_size+1] = 0;
      my_str.assign(text+1); my_str.oem_to_ansi(); tmp_wein.SetName(my_str.c_str());

      stream.read(text, 61); string_size = (unsigned char)(text[0]);
      if(string_size > 59) string_size = 59;
      text[string_size+1] = 0;
      my_str.assign(text+1); my_str.oem_to_ansi(); tmp_wein.SetBezeichnung(my_str.c_str());

      stream.read(text, 11); string_size = (unsigned char)(text[0]);
      if(string_size > 9) string_size = 9;
      text[string_size+1] = 0;
      my_str.assign(text+1); my_str.oem_to_ansi(); tmp_wein.SetFuellmenge(my_str.c_str());

      stream.read((unsigned char*)&gewicht, 2);
      tmp_wein.SetGewicht(gewicht);

		if(strcmp(tmp_wein.GetName(), "") != 0)
		{
			tmp_wein.SetNr(i);
         tmp_wein.SetBestand(100000);
			Add(i);
         *(*this)[i] = tmp_wein;
      } // if
   } // for
} // WeinlistenVerwaltung::ReadPascalFile
